<html>
	<head>
		<title>File Vomitorium - Upload Listing</title>
	</head>
	<body bgcolor=#EEFFEE>
		<h1 align=center>File Vomitorium - Upload Listing</h1>

<?php
	require 'config.php';
	require 'common.php';
	
	emitUploadForm();
	print "<HR>\n";

	# File Vomitorium by Tyler Bletsch (tkbletsc (at) eml.cc)
	#  http://dsss.be/file-vomitorium/
	
	# This is free software; use at your own risk.  Author accepts no 
	# responsibility for the quality of this product.  Feel free to modify or 
	# distribute this code without restriction.

	# Base URL
	$urlbase = getUrlBase();
	
	$sortField = 'date';
	if ($_GET['s']) $sortField = $_GET['s']; # name|date|size


	# build file list
	for ($dp = dir($dataDir); $entry = $dp->read(); ) { $dirs[] = $entry; }
	$dp->close();
	
	# sort it by name/size/date (this could be more efficient if we memoized the sizes/times, but I don't care)
	function cmpDate($a,$b) { global $dataDir; return (filemtime("$dataDir$a") > filemtime("$dataDir$b"))?-1:1; }
	function cmpSize($a,$b) { global $dataDir; return (filesize("$dataDir$a")  < filesize("$dataDir$b") )?-1:1; }
	
	if ($sortField == 'file') natsort($dirs);
	else if ($sortField == 'date') usort($dirs,'cmpDate');
	else if ($sortField == 'size') usort($dirs,'cmpSize');
	
	# emit the files
	$table = "<table align=center border=1>\n";
	$table .= "<tr><th></th>";
	$table .= "<th><a href='?s=file'>File</a>".($sortField == 'file' ? ' &and;' : '')."</th>";
	$table .= "<th><a href='?s=date'>Date</a>".($sortField == 'date' ? ' &or;' : '')."</th>";
	$table .= "<th><a href='?s=size'>Size</a>".($sortField == 'size' ? ' &and;' : '')."</th>";
	$table .= "</tr>\n";
	$sizeTotal=0; $numFiles=0;
	foreach ($dirs as $entry) {
		$path = "$dataDir/$entry";
		if ($entry == "." || $entry == ".." || !is_file($path)) continue; # skip relative paths and non-files
		if ($entry == "index.html" || $entry == "htaccess") continue; # skip special files
		if (ereg("^\.",$entry)) continue; # skip dotfiles
		
		$date = gmdate('Y-m-d H:i:s', filemtime($path));
		$size = filesize($path);
		$sizeFormatted = baseTwoMetricUnits($size)."B";
		$sizeTotal += $size;
		$numFiles++;
		
		$urlFile = str_replace(" ","%20","$urlbase$dataDir$entry");
		$urlView = str_replace(" ","%20","${urlbase}view.php?i=$entry");
		
		$baseName = preg_replace('/(.*)\..*/','$1',$entry);
		
		$table .= "<tr><td><a href='$urlView'><img src='info.gif' border=0></a></td><td><A href='$urlFile'>$entry</a></td><td>$date</td><td>$sizeFormatted</td></tr>\n";
		
	}
	
	$table .= "</table>\n";
	
	print "<div align=center><i>$numFiles files occupy ".baseTwoMetricUnits($sizeTotal)."B.</i><BR>Click the filenames 
to link directly to the file, click the icons to go to the view page for that file.</div>\n";
	print "<HR>\n";
	print $table;
?>

<HR>
<?php emitBottomLine(); ?>

</body></html>
