<?php
	ob_start();

	require 'config.php';
	require 'common.php';

	# File Vomitorium by Tyler Bletsch (tkbletsc (at) eml.cc)
	#  http://dsss.be/file-vomitorium/
	
	# This is free software; use at your own risk.  Author accepts no 
	# responsibility for the quality of this product.  Feel free to modify or 
	# distribute this code without restriction.

function handleUpload() {
	global $maxFileSize, $dataDir;
	
	# Base URL
	$urlbase = getUrlBase();
	
	if (!isset($_FILES['file']) || !$_FILES['file'] || !$_FILES['file']['name']) { 
		header("Location: $urlbase");
		exit;
	}

	# get basename and clean it of dangerous characters
	$basename = basename($_FILES['file']['name']);
	$basename = preg_replace("/[\\\"\`\~\+\|\:\;\[\]\{\}\<\>\,\?\']/",'-',$basename);
	
	# Get basename and extension; validate extension
	if (preg_match("/(.*)(\..*)$/",$basename, $matches)) {
		$filenameBase=$matches[1]; $extension=$matches[2];
	}
	
	# Find a free filename based on given name
	$filename = $dataDir . $basename;
	
	$i=0;	
	while (file_exists($filename)) {
		$i++;
		$basename = "$filenameBase$i$extension";
		$filename = "$dataDir$basename";
	}

	# URLs to the file and its thumbnail
	$urlView = str_replace(" ","%20","${urlbase}view.php?i=$basename");

	# Move temp file to destination
	if (move_uploaded_file($_FILES['file']['tmp_name'], $filename)) {
		header("Location: $urlView"); # Redirect browser
		#print "<a href='$urlView'>$urlView</a><BR>"; # Redirect browser
		exit;

	} else {
		echo "Possible file upload attack! \n";
	}
	

}


handleUpload(); 

?>
